//
// shatbox (C) 2002 Matthew Conte (matt@conte.com)
//
//
// scanline.cpp
//
// scanline expansion
//
// $Id: $
//

#include "scanline.h"
#include "duff.h"

// normal scale
void scan_expand_1(uint8 *pDest, const uint8 *pSrc, uint8 *pPalette, int count)
{
   DUFF(count, *pDest++ = pPalette[*pSrc++]);
}

void scan_expand_2(uint16 *pDest, const uint8 *pSrc, uint16 *pPalette, int count)
{
   DUFF(count, *pDest++ = pPalette[*pSrc++]);
}

void scan_expand_3(uint8 *pDest, const uint8 *pSrc, uint32 *pPalette, int count)
{
   DUFF(count,
        {
           uint32 pixel = pPalette[*pSrc++];
           *pDest++ = pixel & 0xff;
           *pDest++ = (pixel >> 8) & 0xff;
           *pDest++ = (pixel >> 16) & 0xff;
        });
}

void scan_expand_4(uint32 *pDest, const uint8 *pSrc, uint32 *pPalette, int count)
{
   DUFF(count, *pDest++ = pPalette[*pSrc++]);
}

// 2 times scale
void scan_expand_2x_1(uint8 *pDest, const uint8 *pSrc, uint8 *pPalette, int count)
{
   DUFF(count,
        {
           uint8 pixel = pPalette[*pSrc++];
           *pDest++ = pixel;
           *pDest++ = pixel;
        });
}

void scan_expand_2x_2(uint16 *pDest, const uint8 *pSrc, uint16 *pPalette, int count)
{
   DUFF(count,
        {
           uint16 pixel = pPalette[*pSrc++];
           *pDest++ = pixel;
           *pDest++ = pixel;
        });
}

void scan_expand_2x_3(uint8 *pDest, const uint8 *pSrc, uint32 *pPalette, int count)
{
   DUFF(count,
        {
           uint32 color = pPalette[*pSrc++];
           pDest[0] = pDest[3] = color & 0xff;
           pDest[1] = pDest[4] = (color >> 8) & 0xff;
           pDest[2] = pDest[5] = (color >> 16) & 0xff;
           pDest += 6;
        });
}

void scan_expand_2x_4(uint32 *pDest, const uint8 *pSrc, uint32 *pPalette, int count)
{
   DUFF(count, 
        {
           uint32 pixel = pPalette[*pSrc++];
           *pDest++ = pixel;
           *pDest++ = pixel;
        });
}
