;
; scanlinea.asm
;
; assembly version of scanline.c
;
; Copyright (C) 2001 Matthew Conte (matt@conte.com)
;

   BITS 32

   SECTION  .text

   global   _scan_expand_1
   global   _scan_expand_2
   global   _scan_expand_3
   global   _scan_expand_4
   global   _scan_expand_2x_1
   global   _scan_expand_2x_2
   global   _scan_expand_2x_3
   global   _scan_expand_2x_4

%macro   SCAN_ENTER  0
   push  ebx
   push  ebp
   push  esi
   push  edi
   mov   edi,[esp+20]
   mov   esi,[esp+24]
   mov   ebp,[esp+28]
   mov   ecx,[esp+32]
   xor   eax,eax
   xor   ebx,ebx
%endmacro

%macro   SCAN_LEAVE  0
   pop   edi
   pop   esi
   pop   ebp
   pop   ebx
   ret
%endmacro

; sp[4] = *pDest
; sp[8] = *pSrc
; sp[12] = *pPalette
; sp[16] = count

_scan_expand_1:
   SCAN_ENTER
   sub   esi,4
   sub   edi,4
   shr   ecx,2
.loop:
   mov   al,[esi+ecx*4+2]
   mov   bl,[esi+ecx*4+3]
   mov   dl,[ebp+eax]
   mov   al,[esi+ecx*4+0]
   mov   dh,[ebp+ebx]
   mov   bl,[esi+ecx*4+1]
   ror   edx,16
   mov   dl,[ebp+eax]
   mov   dh,[ebp+ebx]
   mov   [edi+ecx*4],edx
   
   loopnz .loop,ecx
   SCAN_LEAVE

_scan_expand_2:
   SCAN_ENTER

   sub   esi,2
   sub   edi,4
   shr   ecx,1
.loop:
   mov   al,[esi+ecx*2]
   mov   bl,[esi+ecx*2+1]
   mov   dx,[ebp+ebx*2]
   ror   edx,16
   mov   dx,[ebp+eax*2]
   mov   [edi+ecx*4],edx   
   loopnz .loop,ecx

   SCAN_LEAVE

_scan_expand_3:
   SCAN_ENTER
   SCAN_LEAVE

_scan_expand_4:
   SCAN_ENTER

   sub   esi,2
   sub   edi,8
   shr   ecx,1
.loop:

   mov   al,[esi+ecx*2]
   mov   bl,[esi+ecx*2+1]
   mov   edx,[ebp+eax*4]
   mov   [edi+ecx*8],edx
   mov   edx,[ebp+ebx*4]
   mov   [edi+ecx*8+4],edx

   loopnz .loop,ecx
   SCAN_LEAVE


_scan_expand_2x_1:
   SCAN_ENTER
   sub   esi,4
   sub   edi,4
   shr   ecx,2
.loop:
   mov   al,[esi+ecx*4+2]
   mov   bl,[esi+ecx*4+3]
   mov   dl,[ebp+eax]
   mov   al,[esi+ecx*4+0]
   mov   dh,[ebp+ebx]
   mov   bl,[esi+ecx*4+1]
   ror   edx,16
   mov   dl,[ebp+eax]
   mov   dh,[ebp+ebx]
   mov   [edi+ecx*4],edx
   
   loopnz .loop,ecx
   SCAN_LEAVE

_scan_expand_2x_2:
   SCAN_ENTER

   sub   esi,2
   sub   edi,4
   shr   ecx,1
.loop:
   mov   al,[esi+ecx*2]
   mov   bl,[esi+ecx*2+1]
   mov   dx,[ebp+ebx*2]
   ror   edx,16
   mov   dx,[ebp+eax*2]
   mov   [edi+ecx*4],edx   
   loopnz .loop,ecx

   SCAN_LEAVE

_scan_expand_2x_3:
   SCAN_ENTER
   SCAN_LEAVE

_scan_expand_2x_4:
   SCAN_ENTER

   sub   esi,2
   sub   edi,8
   shr   ecx,1
.loop:

   mov   al,[esi+ecx*2]
   mov   bl,[esi+ecx*2+1]
   mov   edx,[ebp+eax*4]
   mov   [edi+ecx*8],edx
   mov   edx,[ebp+ebx*4]
   mov   [edi+ecx*8+4],edx

   loopnz .loop,ecx
   SCAN_LEAVE
